/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: SourceWriter.java,v 1.1 2001/09/28 16:01:06 cryd0221 Exp $
 */



/*
    SourceWriter.java
*/

package org.enhydra.dods.builder.engine;

import java.io.*;


/**
 *  SourceWriter
 *
 *      Extends FileWriter, remembers pathname of file.
 */
public class SourceWriter extends FileWriter
{
    /**
     *  SourceWriter
     *    constructor
     *
     *  @param _path
     *    The String pathname of output file to write.
     */
    public SourceWriter( String _path ) throws IOException {
        super( _path );
        path = _path;
        File   f    = new File( path );
        if ( ! f.canWrite() ) {
            System.exit( -1 );
        }
        path = f.getPath();
    }

    /**
     *  getPath
     *    Returns the stored pathname of the written output file.
     *
     *  @return
     *    The pathname as a String.
     */
    public String getPath() {
        return path;
    }

    private String path;
}
