/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: TagSet.java,v 1.1 2001/09/28 16:01:06 cryd0221 Exp $
 */



package org.enhydra.dods.builder.engine;

import java.util.Hashtable;
import java.util.Enumeration;

public class TagSet {
    private Hashtable    tagValues = new Hashtable();
    private final String sep       = ":";
    private String       dupTest   = sep;

    public TagSet() {}

    public void setTagValue( String tag, String value ) throws Exception {
	String old = (String) tagValues.get( "<" + tag + ">" );
	if ( null != old ) {
	    /*
	    System.out.println("Tag '" + tag + "' value was '" 
				+ old + "', is now '" + value + "'" );
	    */
	} else {
	    int index = dupTest.indexOf( tag );
	    if ( -1 != index ) {
		int precedingSep = dupTest.lastIndexOf( sep, index );
		int trailingSep  = dupTest.indexOf(     sep, index );
		throw new Exception( "Tag '" + tag + "' conflicts with: "
		    + dupTest.substring( precedingSep + 1, trailingSep ) );
	    }
	    dupTest += sep + tag;
	}
	tagValues.put( "<" + tag + ">", value );
    }

    public String getTagValue( String tag ) throws Exception {
	String value = (String) tagValues.get( tag );
	if ( null == value )	
	    value = (String) tagValues.get( "<" + tag + ">" );
	if ( null == value )	
	    throw new Exception( "No value for tag '" + tag + "'" );
	return value;
    }

    public Enumeration getTags() throws Exception {
	return tagValues.keys();
    }
}
