/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: TemplateReader.java,v 1.1 2001/09/28 16:01:06 cryd0221 Exp $
 */



/*
    TemplateReader.java
*/

package org.enhydra.dods.builder.engine;

import java.io.*;

/**
 *  TemplateReader
 *
 *      Extends BufferedReader, remembers pathname of file.
 */
public class TemplateReader extends BufferedReader {
    /**
     *  TemplateReader
     *    constructor
     *
     *  @param _path
     *    The pathname to open and remember.
     */
    public TemplateReader( String _path ) {
//    public TemplateReader( String _path ) throws FileNotFoundException {
//        super( new FileReader( _path ) );
        super(new InputStreamReader(TemplateReader.class.getResourceAsStream(_path)));
//System.out.println ("Got stream:"+_path);
        path = _path;
    }

    /**
     *  getPath
     *    Returns the remembered pathname.
     *
     *  @return
     *    The pathname as a String.
     */
    public String getPath() {
        return path;
    }

    private String path;
}
