/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: SourceGenerator_DOI.java,v 1.1 2001/09/28 16:01:06 cryd0221 Exp $
 */




package org.enhydra.dods.builder.generator.datainterface;

import org.enhydra.dods.store.doa.DataObject;
import org.enhydra.dods.store.doa.Attribute;
import org.enhydra.dods.store.doa.DODSProject;

import org.enhydra.dods.builder.engine.*;
import org.enhydra.dods.builder.generator.base.*;

/*
import java.io.*;
import java.io.IOException;
*/
import java.io.File;
import java.io.StringWriter;
import java.util.Vector;

public class SourceGenerator_DOI extends SourceGenerator {

    public SourceGenerator_DOI() throws Exception {
    }

    static public final String BEGIN_NONCONSTANT = "BEGIN_NONCONSTANT";
    static public final String END_NONCONSTANT = "END_NONCONSTANT";

    public void memberPrep(	Attribute a ) throws Exception {
	if ( a.isObjectRef() && a.getObjectRefDO().isAbstract() )
	    Builder.print("ERROR!!: Attribute '" + a.getName()
			+ "' refers to an abstract class." );
	super.memberPrep( a );
	tagSet.setTagValue( BEGIN_NONCONSTANT, beginNoCodeIf( a.isConstant() ));
	tagSet.setTagValue( END_NONCONSTANT,   endNoCodeIf( a.isConstant() ));
    }

    public void writeFileHeader(  DataObject o ) throws Exception {
	defaultWriteFileHeader( o );

         Vector ancestors = o.getAncestors();
      /* System.err.println("ancestors.size()="+ancestors.size()); */
         if ( null != ancestors ) {
            for ( int i = 0; i < ancestors.size(); i++ ) {
               DataObject p = (DataObject) ancestors.elementAt( i );
               if ( null != p ) {
                  Vector members = p.getAttributes();
                  for ( int j = 0; j < members.size(); j++ ) {
                     Attribute attr = (Attribute) members.elementAt( j );
		     memberPrep( attr );
                  }
               }
            }
         }
    }

    public void writeMemberStuff( Attribute  a ) throws Exception {
/* System.err.println("--- writeMemberStuff: a="+a.getName()); */
	defaultWriteMemberStuff( a );
    }

    public void writeFileFooter(  DataObject o ) throws Exception {
/* System.err.println("--- writeFileFooter"); */
	defaultWriteFileFooter( o );
    }

}
