/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: SourceGenerator_DO.java,v 1.1 2001/09/28 16:01:06 cryd0221 Exp $
 */




package org.enhydra.dods.builder.generator.dataobject;

import org.enhydra.dods.store.doa.DataObject;
import org.enhydra.dods.store.doa.Attribute;
import org.enhydra.dods.store.doa.DODSProject;

import org.enhydra.dods.builder.engine.*;
import org.enhydra.dods.builder.generator.base.*;

/*
import java.io.*;
import java.io.IOException;
*/
import java.io.File;
import java.io.StringWriter;
import java.util.*;

public class SourceGenerator_DO extends SourceGenerator {

    final String DATA_STRUCT			= "DATA_STRUCT";
    final String TO_STRING			= "TO_STRING";
    final String ABSTRACT			= "ABSTRACT";
    //final String BEGIN_CONCRETE			= "BEGIN_CONCRETE";
    //final String END_CONCRETE			= "END_CONCRETE";
    //final String BEGIN_LEAF			= "BEGIN_LEAF";
    //final String END_LEAF			= "END_LEAF";
    //final String LEAF_ONLY			= "LEAF_ONLY";
    final String NOT_LOADING			= "NOT_LOADING";

    //final String IMPORT_PARENT			= "IMPORT_PARENT";
    final String INSERT_QUESTION_MARKS		= "INSERT_QUESTION_MARKS";
    final String INSERT_COLUMN_NAMES		= "INSERT_COLUMN_NAMES";
    final String UPDATE_QUAL_QUESTION_MARKS	= "UPDATE_QUAL_QUESTION_MARKS";
    final String UPDATE_WHERE_CLAUSE		= "UPDATE_WHERE_CLAUSE";
    final String UPDATE_WHERE_VALUES		= "UPDATE_WHERE_VALUES";
    final String RESULT_SET_EXTRACTION_CALLS	= "RESULT_SET_EXTRACTION_CALLS";
    final String RESULT_SET_EXTRACTION_FOR_LONG_CALLS	= "RESULT_SET_EXTRACTION_FOR_LONG_CALLS";
    final String PARAM_SET_OID			= "PARAM_SET_OID";
    final String UPDATE_PARAM_SET_CALLS		= "UPDATE_PARAM_SET_CALLS";
    final String PREP_STMT_PARAM_CALLS		= "PREP_STMT_PARAM_CALLS";

    final String CAST_TO_DO			= "CAST_TO_DO";
    final String REFERENCED_DO_EXCEPTIONS	= "REFERENCED_DO_EXCEPTIONS";
    final String REFERENCE_OID_TYPE		= "REFERENCE_OID_TYPE";
    final String BEGIN_CREATE_EXISTING		= "BEGIN_CREATE_EXISTING";
    final String END_CREATE_EXISTING		= "END_CREATE_EXISTING";
    final String ENABLE_CACHE			= "ENABLE_CACHE";
    final String LAZY_LOADING			= "LAZY_LOADING";
//    final String IS_VIEW			= "IS_VIEW";

//    final String TRUE_IF_NOT_NULL		= "TRUE_IF_NOT_NULL";

    final protected String ARRAY_DO_NAME        = "ARRAY_DO_NAME";
    final protected String ARRAY_QUERY_NAME     = "ARRAY_QUERY_NAME";
    final protected String ARRAY_GET_METHODS    = "ARRAY_GET_METHODS";

    final protected String SUPER_LOADDATA       = "SUPER_LOADDATA";

    final protected String DUMP_METHOD          = "DUMP_METHOD";
    final protected String MEMBER_REMARKS       = "MEMBER_REMARKS";
    String memberRemarks = "";

// GET_REFERRERS scrapped in favor of N21_REFERRERS
/*     final protected String GET_REFERRERS        = "GET_REFERRERS"; */
    final protected String REFERRER             = "REFERRER";
    final protected String FULL_REFERRER             = "FULL_REFERRER";
    final protected String GET_ARRAY_METHOD_NAME
						= "GET_ARRAY_METHOD_NAME";
    final protected String GET_SINGLE_METHOD_NAME
						= "GET_SINGLE_METHOD_NAME";

    //final protected String DECL_MAX_LENGTH	= "DECL_MAX_LENGTH";

//    final String defaultStringLength		= "32";


    // template reader and filter for JDBCsetCall.template file.
    private TemplateFilter filterJDBCsetCalls;
    private StringWriter   JDBCsetCalls;
    private TemplateFilter filterJDBCsetCallForNonOidPK;
    private StringWriter   JDBCsetCallForNonOidPK;

    // template reader and filter for ResultSetExtraction.template file.
    private TemplateFilter filterResultSetExtractions;
    private StringWriter   ResultSetExtractions;
    // Columns with database type LONG must be pulled from the ResultSet
    // before any other columns to avoid a "Stream already closed" error.
    private TemplateFilter filterResultSetExtractionForLONG;
    private StringWriter   ResultSetExtractionForLONG;

    // template reader and filter for toString.template file.
    private TemplateFilter filterMemberDump;
    private StringWriter   memberDump;

    // template reader and filter for HandleArray.template file.
    private TemplateFilter filterHandleArray;
    private StringWriter   handleArray;

    /*
    // template reader and filter for getReferrers.template file.
    private TemplateFilter filterGetReferrers;
    private StringWriter   getReferrers;
    */

    // former BDO stuff

    final String QUERY_CLASS_NAME	= "QUERY_CLASS_NAME";
    final String START_NO_REFS	        = "START_NO_REFS";
    final String STOP_NO_REFS	        = "STOP_NO_REFS";
    final String STUBS_FOR_COMMIT_ASSERTIONS = "STUBS_FOR_COMMIT_ASSERTIONS";
    final String COMMIT_REFERENCED_DOS	     = "COMMIT_REFERENCED_DOS";
    final String MEMBER_DO_CLASS_NAME	     = "MEMBER_DO_CLASS_NAME";
    final String NULL_OK	     = "NULL_OK";
    final String BEGIN_NO_CASCADE_DELETE     = "BEGIN_NO_CASCADE_DELETE";
    final String END_NO_CASCADE_DELETE       = "END_NO_CASCADE_DELETE";

    final protected String N21_REFERRERS        = "N21_REFERRERS";
    final protected String N2N_REFERRERS        = "N2N_REFERRERS";
    final protected String REFERRED             = "REFERRED";
    final protected String FULL_REFERRED             = "FULL_REFERRED";
    final protected String REFERRED_VIA             = "REFERRED_VIA";
    final protected String GET_ATTR             = "GET_ATTR";
    final protected String THIS_ATTR            = "THIS_ATTR";
    final protected String GET_SINGLE_DO_METHOD_NAME = "GET_SINGLE_DO_METHOD_NAME";
    final protected String GET_ARRAY_DO_METHOD_NAME = "GET_ARRAY_DO_METHOD_NAME";
    final protected String ADD_DO_METHOD_NAME = "ADD_DO_METHOD_NAME";
    final protected String REMOVE_DO_METHOD_NAME = "REMOVE_DO_METHOD_NAME";
    final protected String CASCADING_DELETES = "CASCADING_DELETES";

    static String FK_REF = "FK_REF";
    static String FK_REF_GET_METHOD = "FK_REF_GET_METHOD";
    static String FK_REF_SET_METHOD = "FK_REF_SET_METHOD";
    static String FK_SETQUERY_CALLS = "FK_SETQUERY_CALLS";
    static String FK_SET_CALLS = "FK_SET_CALLS";
    static String FK_GET_SET_METHODS = "FK_GET_SET_METHODS";
    static String UPPER_FK_MEM_NAME = "UPPER_FK_MEM_NAME";
    static String UPPER_PK_MEM_NAME = "UPPER_PK_MEM_NAME";
    static String START_MEMBER_NOT_IN_COMBO_FK = "START_MEMBER_NOT_IN_COMBO_FK";
    static String END_MEMBER_NOT_IN_COMBO_FK = "END_MEMBER_NOT_IN_COMBO_FK";
    static String START_MEMBER_IN_COMBO_FK = "START_MEMBER_IN_COMBO_FK";
    static String END_MEMBER_IN_COMBO_FK = "END_MEMBER_IN_COMBO_FK";
    static String SET_COMBO_FK_USING_DO_METHOD = "SET_COMBO_FK_USING_DO_METHOD";
    private Hashtable numColumnsInFK = null;
    private Hashtable fkNameByFkRef = null;

    // template reader and filter for StubForCommitAssertion.template file.
    private TemplateFilter filterStubForCommitAssertions;
    private StringWriter   StubForCommitAssertions;

    // template reader and filter for CommitDeleteOtherDO.template file.
    private TemplateFilter filterCommitDeleteOtherDOs;
    private StringWriter   CommitDeleteOtherDOs;

    // template reader and filter for manyToOneReferrers.template file.
    private TemplateFilter filterN21Referrers;
    private StringWriter   n21Referrers;

    // template reader and filter for manyToManyReferrers.template file.
    private TemplateFilter filterN2NReferrers;
    private StringWriter   n2nReferrers;

    // template reader and filter for CascadingDelete.template file.
    // Given a relationship like
    //		Person		Address
    //		oid <---------- person
    // a Person.delete() will cause an Address.delete().
    // Note that an Address.delete() will not cause a Person.delete().
    //
    // For this reason, all 1-1 relationships should be expressed as
    // back-pointers.  That is, the 1-1 relationship between Person and Address
    // should *NOT* be expressed in a DODS project as
    //		Person		Address
    //		addr ---------> oid
    // even though that is more instinctive from an OO design perspective.
    private TemplateFilter filterCascadingDeletes;
    private StringWriter   cascadingDeletes;

    public SourceGenerator_DO() throws Exception {
    }

   /**
     * Adds tag values to the <CODE>TagSet</CODE>.
     * These methods should invoke
     *    <CODE>TemplateFilter.process( tagSet )</CODE>
     * which will create the output source file.
     *
     * @param o
     *   DataObject for which source code will be generated by
     *    <CODE>writeFileHeader</CODE> and
     *    <CODE>writeFileFooter</CODE>
     * @exception Exception
     *   If an unrecoverable error occurs.
     */
    public void objectPrep(	GeneratorInfo sgi,
				DODSProject project,
				DataObject o )
    throws Exception {
	super.objectPrep( sgi, project, o );

	generateFKstuff( o );

	TemplateReader reader = new TemplateReader(
	     info.templateDir + File.separator + "JDBCsetCall.template" );
	JDBCsetCalls = new StringWriter();
	filterJDBCsetCalls = new TemplateFilter(
					reader, JDBCsetCalls );

	// use JDBCsetCallForNonOidPK.template for FK set calls used in 
	// update/deletes (if DO is NOT_OID_BASED)
	reader = new TemplateReader(
	     info.templateDir + File.separator + "JDBCsetCallForNonOidPK.template" );
	JDBCsetCallForNonOidPK = new StringWriter();
	filterJDBCsetCallForNonOidPK = new TemplateFilter(
					reader, JDBCsetCallForNonOidPK );

	reader = new TemplateReader(
	     info.templateDir + File.separator + "ResultSetExtraction.template" );
	ResultSetExtractions = new StringWriter();
	filterResultSetExtractions = new TemplateFilter(
					reader, ResultSetExtractions );

	reader = new TemplateReader(
	     info.templateDir + File.separator + "ResultSetExtractionForLONG.template" );
	ResultSetExtractionForLONG = new StringWriter();
	filterResultSetExtractionForLONG = new TemplateFilter(
					reader, ResultSetExtractionForLONG );

	reader = new TemplateReader(
	     info.templateDir + File.separator + "toString.template" );
	memberDump = new StringWriter();
	filterMemberDump = new TemplateFilter( reader, memberDump );

	reader = new TemplateReader(
	     info.templateDir + File.separator + "HandleArray.template" );
	handleArray = new StringWriter();
	filterHandleArray = new TemplateFilter( reader, handleArray );

	/*
	reader = new TemplateReader(
	     info.templateDir + File.separator + "getReferrers.template" );
	getReferrers = new StringWriter();
	filterGetReferrers = new TemplateFilter( reader, getReferrers );
	*/

	// former BDO stuff

/* 	tagSet.setTagValue( DO_CLASS_NAME,    o.getName() + "DO" ); */
	tagSet.setTagValue( QUERY_CLASS_NAME, o.getName() + "Query" );

	tagSet.setTagValue( BEGIN_NO_CASCADE_DELETE,
					beginNoCodeIf( cascadeDelete ));
	tagSet.setTagValue( END_NO_CASCADE_DELETE,
					endNoCodeIf( cascadeDelete ));

        reader = new TemplateReader(
             info.templateDir + File.separator
		+ "CommitDeleteOtherDO.template" );
        CommitDeleteOtherDOs = new StringWriter();
        filterCommitDeleteOtherDOs = new TemplateFilter(
                                        reader, CommitDeleteOtherDOs );

        reader = new TemplateReader(
             info.templateDir + File.separator
		+ "StubForCommitAssertion.template" );
        StubForCommitAssertions = new StringWriter();
        filterStubForCommitAssertions = new TemplateFilter(
                                        reader, StubForCommitAssertions );

        reader = new TemplateReader(
             info.templateDir +File.separator+ "manyToOneReferrers.template" );
        n21Referrers = new StringWriter();
        filterN21Referrers = new TemplateFilter( reader, n21Referrers );

        reader = new TemplateReader(
             info.templateDir +File.separator+ "manyToManyReferrers.template" );
        n2nReferrers = new StringWriter();
        filterN2NReferrers = new TemplateFilter( reader, n2nReferrers );

        reader = new TemplateReader(
             info.templateDir +File.separator+ "CascadingDeletes.template" );
        cascadingDeletes = new StringWriter();
        filterCascadingDeletes = new TemplateFilter( reader, cascadingDeletes );

        getAddDelReferrers( o, project );

	// resume DO stuff

/* 	getReferrers( o, project ); */

	boolean isAbstract = o.isAbstract();

	tagSet.setTagValue( DATA_STRUCT,    o.getName() + "DataStruct" );
	tagSet.setTagValue( ENABLE_CACHE,   o.isFullCaching() ? "true":"false");

	boolean allLazy = Builder.getBoolProp( Builder.PROP_LAZY );
	tagSet.setTagValue( LAZY_LOADING,   
		( allLazy || o.isLazyLoading() ) ? "true":"false");

//	tagSet.setTagValue( IS_VIEW,        o.isView() ? "true":"false");
	tagSet.setTagValue( ABSTRACT,       isAbstract ? "abstract" : "" );
	//tagSet.setTagValue( BEGIN_CONCRETE, isAbstract ? "/*" : "" );
	//tagSet.setTagValue( END_CONCRETE,   isAbstract ? "*/" : "" );
	Vector v = o.getDescendents();
	boolean isLeaf = ( null == v || 0 == v.size() );
	/* FIX (see "concrete-non-leaf" note in Builder.java)
	   It really doesn't make sense
	   to derive a concrete DO from another concrete DO.
	   To do so would raise a number of implementation problems:
	   1)  If each DO has its own table, then
	       you'd get tables with redundant data.
	   2)  If both DOs reside in the same table,
	       A) you'd have wasted columns for the parent class
	       B) you'd need an extra column to indicate the class
		  that a given row represents.
	   So, Philip is changing the GUI so that when class B is
	   derived from class A, class A is automatically made 'abstract'.
	   Until this is done, we force it to be so.
	*/
	if ( o.isAbstract() || ! isLeaf )
	    tagSet.setTagValue( NOT_LOADING, "true" );
	else
	    tagSet.setTagValue( NOT_LOADING, "false" );
	//tagSet.setTagValue( BEGIN_LEAF,       isLeaf ? "" : "/*" );
	//tagSet.setTagValue( END_LEAF,         isLeaf ? "" : "*/" );
	//tagSet.setTagValue( LEAF_ONLY,        isLeaf ? "" : "// " );

	// These tags must have values even if there are no Attributes
	// (a stupid situation for a Data Object to be in.)
	tagSet.setTagValue( CAST_TO_DO, "" );
	tagSet.setTagValue( REFERENCED_DO_EXCEPTIONS, "" );
	tagSet.setTagValue( REFERENCE_OID_TYPE, "");
	tagSet.setTagValue( BEGIN_CREATE_EXISTING, "");
	tagSet.setTagValue( END_CREATE_EXISTING, "");

	DataObject parent = o.getExtensionOf();
	String parentName = null;
	if ( null != parent )
	    parentName = parent.getName();
	if ( null == parentName || -1 != parentName.indexOf( "GenericDO" ) )
	    tagSet.setTagValue( SUPER_LOADDATA, "");
	else
	    tagSet.setTagValue( SUPER_LOADDATA, "super.loadData();");


    	// FIX remove to end of method
	/* Do not generate commit() and delete() convenience methods
	 * for DO's that have references to other DO's.
	 * See template for details.
	 */
	/*
	boolean has_refs = false;
	Vector attrs = o.getAttributes();
	for ( int i = 0; i < attrs.size(); i++ ) {
	    Attribute a = (Attribute) attrs.elementAt( i );
	    if ( a.isObjectRef() ) {
		has_refs = true;
	    }
	}
	tagSet.setTagValue( START_NO_REFS, beginNoCodeIf( has_refs ) );
	tagSet.setTagValue( STOP_NO_REFS,  endNoCodeIf( has_refs ) );
	*/
    }

    /**
    *
    *  This algorithm generates short or long method names.
    *  Consider the following example Data Objects used by a telephone company:
    *	    Data Object	Attribute type,	name
    *	    -----------	--------------	-----------
    *	    Phone	int		phoneNumber
    *	    Person	PhoneDO,	phone
    *	    Business	PhoneDO,	mainPhone
    *	    Business	PhoneDO,	faxPhone
    *   Multiple Persons can share the same Phone,
    *   and (in this example) multiple Businesses can share the same Phone.
    *   We generate the following method names for the PhoneDO class:
    *	    return type	method name
    *	    -----------	------------------------------------
    *	    PersonDO[]	Phone.getPersonDOArray()
    *	    PersonDO[]	Phone.getBusinessDOArray_mainPhone()
    *	    PersonDO[]	Phone.getBusinessDOArray_faxPhone()
    *	The telephone company would find all the Persons
    *	with the same home phone number by invoking
    *	    Phone.getPersonDOArray()
    *	        (a short method name, since Person has
    *	         just 1 Attribute referring to Phone)
    *	and find all the Businesses using a given fax line by invoking
    *	    Phone.getBusinessDOArray_faxPhone()
    *	        (a long method name, since Business has
    *	         more than 1 Attribute referring to Phone)
    */
    /*
    private void getReferrers( DataObject obj, DODSProject project )
    throws Exception {
System.err.println("getReferrers: obj.getName()="+obj.getName());
	filterGetReferrers.reset();
	DataObject[] all = Builder.getAllDataObjects( project );
	for ( int i = 0; i < all.length; i++ ) {
	    DataObject DO = all[ i ];
	    if ( DO.isAbstract() )
		continue;
	    Vector attrs = DO.getAttributes();
	    if ( null != attrs ) {
		Vector refs = new Vector();
		for ( int j = 0; j < attrs.size(); j++ ) {
		    Attribute attr = (Attribute) attrs.elementAt( j );
		    if ( attr.isObjectRef()
		      && attr.getObjectRefDO() == obj
		      && attr.isUsedForQuery() )
		    {
System.err.println("getReferrers: DO.getName()="+DO.getName() + ", attr="+attr.getName());
			refs.addElement( attr );
		    }
		}
		for ( int k = 0; k < refs.size(); k++ ) {
      if ( ! DO.isAbstract()) {
		    String DOname = DO.getName();
		    Attribute attr = (Attribute) refs.elementAt( k );
System.err.println("getReferrers: REF="+attr.getName());
		    String get_single = "get" + DOname + "DO";
		    String get_array  = "get" + DOname + "DOArray";
		    if ( 1 < refs.size() ) {
			get_single += "_" + attr.getName();
			get_array  += "_" + attr.getName();
		    }
		    memberPrep( attr );
		    tagSet.setTagValue( GET_SINGLE_METHOD_NAME, get_single );
		    tagSet.setTagValue( GET_ARRAY_METHOD_NAME,  get_array );
		    tagSet.setTagValue( REFERRER, DOname );
		    tagSet.setTagValue( FULL_REFERRER,
					DO.getPackageName() + "." + DOname );
		    filterGetReferrers.reset();
		    filterGetReferrers.process( tagSet );
//System.err.println("getReferrers ="+getReferrers );
      }
		}
	    }
	}
    }
*/

    /**
    *
    *  This algorithm generates short or long method names.
    *  Consider the following example Data Objects used by a telephone company:
    *       Data Object		Attribute type, name
    *       -----------		--------------  -----------
    *       Phone       	int             phoneNumber
    *       Person      	PhoneDO,        phone
    *       Business    	PhoneDO,        mainPhone
    *       Business    	PhoneDO,        faxPhone
    *   Multiple Persons can share the same Phone,
    *   and (in this example) multiple Businesses can share the same Phone.
    *   We generate the following method names for the PhoneDO class:
    *       return type 	method name
    *       ----------- 	------------------------------------
    *       PersonDO[]  	PhoneDO.getPersonDOArray()
    *       PersonDO[]  	PhoneDO.getBusinessDOArray_mainPhone()
    *       PersonDO[]  	PhoneDO.getBusinessDOArray_faxPhone()
    *   The telephone company would find all the Persons
    *   with the same home phone number by invoking
    *       Phone.getPersonDOArray()
    *           (a short method name, since Person has
    *            just 1 Attribute referring to Phone)
    *   and find all the Businesses using a given fax line by invoking
    *       Phone.getBusinessDOArray_faxPhone()
    *           (a long method name, since Business has
    *            more than 1 Attribute referring to Phone)
    *
    *	Ok.  That's the many-to-one (n21) case.
    *
    *   Now for the many-to-many (n2n) case.
    *	Consider another example:
    *	    Data Object		Attribute type, name
    *       -----------		--------------  -----------
    *       Person      	PhoneDO,        phone
    *       Team        	String,         name
    *       Person_Team 	PersonDO,       person
    *       Person_Team 	TeamDO,         team
    *	The Person_Team table has 2 attributes, a PersonDO ref & a TeamDO ref.
    *	So, a Person can be on >1 Team, and a Team can have >1 Person.
    *   To make it easy to find out what Persons are on a Team,
    *   we could use the method generated by the one-to-many stuff above
    *       return type		method name
    *       -----------		------------------------------------
    *       PersonDO[]		Person_TeamDO.getPersonDOArray()
    *   But the Person_Team table is really a contrivance to get the correct
    *   relationships expressed in the database (i.e. an implementation detail.)
    *   It would be better to have a method
    *       PersonDO[]  TeamDO.getPersonDOArray()
    *   to allow the application to avoid dealing with the Person_Team table.
    *   The many-to-many handling below would generate the methods
    *       PersonDO[]		TeamDO.getPersonDOArray()
    *       TeamDO[]		PersonDO.getTeamDOArray()
    *   unless Person itself had a reference to Team
    *   or if  Team   itself had a reference to Person
    *   in which case the purpose of the Person_Team table becomes unclear.
    */
    private void getAddDelReferrers( DataObject obj, DODSProject project )
    throws Exception {
//System.err.println("getAddDelReferrers: obj.getName()="+obj.getName());
	if ( obj.isAbstract() )
	    return;
        filterN21Referrers.reset();
        filterN2NReferrers.reset();
        DataObject[] all = Builder.getAllDataObjects( project );
	Attribute attr  = null;
	Attribute attr2 = null;
	boolean DO_is_N2N_map;
        for ( int i = 0; i < all.length; i++ ) {
            DataObject DO = all[ i ];
	    if ( DO.isAbstract() )
		continue;
	    DataObject DO2 = null;
	    DO_is_N2N_map = false;
            Vector attrs = DO.getAttributes();
            if ( null == attrs )
		continue;
	    Vector refsN21 = new Vector();
	    Vector refsN2N = new Vector();

	    // we are only interested in the attrs that are obj references.
	    Vector refAttrs = new Vector();
	    for ( int j = 0; j < attrs.size(); j++ ) {
		attr = (Attribute) attrs.elementAt( j );
		if ( attr.isObjectRef() && attr.isUsedForQuery() && ! attr.isForeignKey() )
		    if ( ! attr.getObjectRefDO().isAbstract() )
			refAttrs.addElement( attr );
	    }

	    //for ( int j = 0; j < attrs.size(); j++ )
	    for ( int j = 0; j < refAttrs.size(); j++ ) {
		//attr = (Attribute) attrs.elementAt( j );
		attr = (Attribute) refAttrs.elementAt( j );
		if ( attr.getObjectRefDO() != obj )
		    continue;
//System.err.println("getAddDelReferrers n21: DO.getName()="+DO.getName() + ", attr="+attr.getName());
		refsN21.addElement( attr );

		// An N-to-N object mapping table has just 2 obj-ref attributes:
		// 2 references into different tables.
		// (It might have other attributes as well.)
		// If DO has just 2 obj-ref attributes and the other attribute
		// is a ref to a different DO, we generate N-to-N
		// access methods for those other DOs.
		if ( 2 != refAttrs.size() )
		    continue;
		int k = ( 0 == j ? 1 : 0 );  // look at other attr
		attr2 = (Attribute) refAttrs.elementAt( k );

		// does other attr refer to some other DO?
		// if obj is Person, attr is Person_Team.team
		// (see example above)
/*
		if ( ! (   attr2.isObjectRef()
//			&& attr2.getObjectRefDO() != obj
		        && attr2.isUsedForQuery() ) )
		    continue;
*/
//System.err.println("getAddDelReferrers n2n: DO.getName()="+DO.getName() + ", attr="+attr.getName());
		DO2 = attr2.getObjectRefDO();
		if ( DO2.isAbstract() )
		    continue;
		// At this point we suspect that DO expresses a many-to-many
		// relationship between obj and DO2.  (Read that again.)
		// But, if obj has a ref to DO2, or if DO2 has a ref to obj,
		// then the purpose of DO becomes unclear,
		// and we don't generate any access methods to DO2 for obj.
		if ( DOhasRefToDO( obj, DO2 ) || DOhasRefToDO( DO2, obj ) )
		    continue;

//System.err.println("getAddDelReferrers n2n: DO.getName()="+DO.getName() + ", attr2="+attr2.getName());
		
		// If obj and DO2 are the same, then
		// DO has two refs to obj.
		// This is not a many-to-many case.
		if ( obj == DO2 )
		    continue;

		DO_is_N2N_map = true;
	    }		// end for j (looping thru attrs of DO)

	    // generate convenience methods for many-to-one relationships
	    String DOname = DO.getName();
	    for ( int k = 0; k < refsN21.size(); k++ ) {
		attr = (Attribute) refsN21.elementAt( k );
		String get_single_DO  = "get" + DOname + "DO";
		String get_array_DO   = "get" + DOname + "DOArray";
		String add_single_DO  = "add" + DOname + "DO";
		String remove_single_DO  = "remove" + DOname + "DO";
		if ( 1 < refsN21.size() ) {
		    get_single_DO  += "_" + attr.getName();
		    get_array_DO   += "_" + attr.getName();
		    add_single_DO += "_" + attr.getName();
		    remove_single_DO += "_" + attr.getName();
		}

		// manyToOneReferrers.template needs the
		// UPPER_MEMBER_NAME tag set to the referring attr name.
		super.memberPrep( attr );

		tagSet.setTagValue( GET_SINGLE_DO_METHOD_NAME,
						    get_single_DO );
		tagSet.setTagValue( GET_ARRAY_DO_METHOD_NAME,
						    get_array_DO );
		tagSet.setTagValue( ADD_DO_METHOD_NAME,
						    add_single_DO );
		tagSet.setTagValue( REMOVE_DO_METHOD_NAME,
						    remove_single_DO );
		tagSet.setTagValue( REFERRER, DOname );
		tagSet.setTagValue( FULL_REFERRER,
			DO.getPackageName() + "." + DOname );
		filterN21Referrers.reset();
		filterN21Referrers.process( tagSet );
		filterCascadingDeletes.reset();
		filterCascadingDeletes.process( tagSet );
            }

	    if ( DO_is_N2N_map ) {
		String DO2name = DO2.getName();
		//String get_single_DO  = "get" + DO2name + "DO";
		String get_array_DO   = "get" + DO2name + "DOArray_via_" + DOname;
		// manyToOneReferrers.template needs the
		// UPPER_MEMBER_NAME tag set to the referring attr name.
		super.memberPrep( attr );

		//tagSet.setTagValue( GET_SINGLE_DO_METHOD_NAME, get_single_DO );
		tagSet.setTagValue( GET_ARRAY_DO_METHOD_NAME, get_array_DO );
		tagSet.setTagValue( REFERRER, DOname );
		tagSet.setTagValue( REFERRED, DO2name );
		tagSet.setTagValue( REFERRED_VIA, DO2name + "_via_" + DOname );
		tagSet.setTagValue( FULL_REFERRER,
			DO.getPackageName() + "." + DOname );
		tagSet.setTagValue( FULL_REFERRED,
			DO2.getPackageName() + "." + DO2name );
		String name = attr2.getName();
		String firstChar = name.substring( 0, 1 ).toUpperCase();
		name = firstChar + name.substring( 1 );
		tagSet.setTagValue( GET_ATTR, name );
		name = attr.getName();
		firstChar = name.substring( 0, 1 ).toUpperCase();
		name = firstChar + name.substring( 1 );
		tagSet.setTagValue( THIS_ATTR, name );

		filterN2NReferrers.reset();
		filterN2NReferrers.process( tagSet );
	    }
        }
    }

    private boolean DOhasRefToDO( DataObject o1, DataObject o2 ) {
	Vector attrs = o1.getAttributes();
	for ( int i = 0; i < attrs.size(); i++ ) {
	    Attribute attr = (Attribute) attrs.elementAt( i );
	    if ( attr.isObjectRef()
	      && attr.getObjectRefDO() == o2
	      && attr.isUsedForQuery() && ! attr.isForeignKey() )
	    {
		return true;
	    }
	}
	return false;
    }

    public void memberPrep(	Attribute a ) throws Exception {
	if ( a.isObjectRef() && a.getObjectRefDO().isAbstract() )
	    Builder.print("ERROR!!: Attribute '" + a.getName()
			+ "' refers to an abstract class." );
	super.memberPrep( a );

	/* For a field that is an object reference to another Data Object,
	 * the type of the field will be a class derived from GenericDO.
	 * The GenericDO.markNewValue() method that handles such fields
	 * takes GenericDO objects as parameters and returns a GenericDO.
	 * The call to this form of markNewValue() must cast the return value
	 * from GenericDO to the derived class.
	 */
	tagSet.setTagValue( START_MEMBER_NOT_IN_COMBO_FK, "" );
	tagSet.setTagValue( END_MEMBER_NOT_IN_COMBO_FK,  "" );
	tagSet.setTagValue( START_MEMBER_IN_COMBO_FK, TemplateFilter.skipStart);
	tagSet.setTagValue( END_MEMBER_IN_COMBO_FK,   TemplateFilter.skipStop );
	tagSet.setTagValue( DUMP_METHOD, "data." + a.getName() );
	if ( a.isObjectRef() ) {
	    if ( ! a.isForeignKey() ) {
		tagSet.setTagValue( CAST_TO_DO, "(" + a.getJavaType() + ")" );
		tagSet.setTagValue( REFERENCED_DO_EXCEPTIONS,
				", DatabaseManagerException");
				//", DataObjectException");
		tagSet.setTagValue( BEGIN_CREATE_EXISTING,
			    a.getJavaType() + ".createExisting( ");
		tagSet.setTagValue( END_CREATE_EXISTING,   " )");

		tagSet.setTagValue( MEMBER_JDBC_TYPE, val( OID_JDBC_TYPE ) );
//	        tagSet.setTagValue( MEMBER_JAVA_TYPE_SAFE_NAME, oidJdbcType );
//	        tagSet.setTagValue( REFERENCE_OID_TYPE, ".getOId().toBigDecimal()");
		tagSet.setTagValue( MEMBER_JAVA_TYPE_SAFE_NAME, "DO" );
		tagSet.setTagValue( REFERENCE_OID_TYPE, "");

		/* DUMP_METHOD was used to prevent recursion in the
		* DO.toString() method that would occur when
		* DO1 had a ref to DO2 and DO2 had a ref back to DO1.
		* The recursion was caused by printing
		*		DO1.data.DO2
		* To avoid this, DUMP_METHOD was used to print
		*		DO1.data.DO2.getOId()
		* But this type of recursion is too infrequent,
		* and it is too valuable to see the entire dump of ref'd objects.
		* So, DUMP_METHOD is not being used.
		*/
		//tagSet.setTagValue( DUMP_METHOD, ".getOId()" );
		//tagSet.setTagValue( DUMP_METHOD, "" );
		tagSet.setTagValue( DUMP_METHOD, 
		    "( null == data." + a.getName() + 
		    " ? null " +
		    " : data." + a.getName() + ".toString( indentCount + 1 ) )" );

	    } else {
		Integer numColumnsInForeignKey = (Integer) numColumnsInFK.get(
							    a.getName() );
//System.err.println("numColumnsInForeignKey ="+numColumnsInForeignKey );
		if ( null != numColumnsInForeignKey ) {
//System.err.println("numColumnsInForeignKey.intValue()="+numColumnsInForeignKey.intValue());
		    if ( numColumnsInForeignKey.intValue() >= 2 ) {
			tagSet.setTagValue( START_MEMBER_NOT_IN_COMBO_FK, 
				    TemplateFilter.skipStart );
			tagSet.setTagValue( END_MEMBER_NOT_IN_COMBO_FK, 
				    TemplateFilter.skipStop );
			tagSet.setTagValue( START_MEMBER_IN_COMBO_FK, "" );
			tagSet.setTagValue( END_MEMBER_IN_COMBO_FK, "" );
			String altMethod = (String) 
			    fkNameByFkRef.get( a.getName() );
//System.err.println("altMethod ="+altMethod );
			if ( null != altMethod ) 
			    tagSet.setTagValue( SET_COMBO_FK_USING_DO_METHOD, 
				"set" + altMethod + "DO" );
		    }
		}
	    }
	} else {
	    tagSet.setTagValue( CAST_TO_DO, "" );
	    tagSet.setTagValue( REFERENCED_DO_EXCEPTIONS, "" );
	    tagSet.setTagValue( REFERENCE_OID_TYPE, "");
	    tagSet.setTagValue( BEGIN_CREATE_EXISTING, "");
	    tagSet.setTagValue( END_CREATE_EXISTING, "");
	}

	/* For an array Attribute, we use a separate template. */
	if ( a.isArray() ) {
	    tagSet.setTagValue( ARRAY_QUERY_NAME,
		currentObj.getAdjustedPackageName() + "." +
		currentObj.getName() + "_" + a.getName() + "Query" );
	    tagSet.setTagValue( ARRAY_DO_NAME,
		currentObj.getName() + "_" + a.getName() + "DO" );
	}

	if ( a.isObjectRef() && ! a.isForeignKey() ) {
	    DataObject ao = a.getObjectRefDO();
	    String refName = ao.getName();
	    String currentName = currentObj.getName();
	    if ( ! currentName.equals( refName ) ) {

	    tagSet.setTagValue( MEMBER_DO_CLASS_NAME,
		ao.getPackageName() + "." + ao.getName() + "DO" );

	    if ( a.canBeNull() )
		tagSet.setTagValue( NULL_OK,  "true" );
	    else
		tagSet.setTagValue( NULL_OK,  "false" );
	    filterStubForCommitAssertions.reset();
	    filterStubForCommitAssertions.process( tagSet );

	    filterCommitDeleteOtherDOs.reset();
	    filterCommitDeleteOtherDOs.process(    tagSet );
	    }
	}

	memberRemarks = "";
    }

    private String sql_insert_column_names   = "";
    private String sql_insert_question_marks = "";
    private String sql_update_question_marks = "";

    public void writeFileHeader(  DataObject o ) throws Exception {
	/*
	if ( null != info.extraClasspath )
		tagSet.setTagValue( IMPORT_PARENT, info.extraClasspath );
	*/
	defaultWriteFileHeader( o );
	sql_insert_column_names = "";
	sql_update_question_marks = "";
	if ( 0 == o.getPrimaryKeys().length )
	    sql_insert_question_marks = "?, ?, ";  // oid and version

         Vector ancestors = o.getAncestors();
      /* System.err.println("ancestors.size()="+ancestors.size()); */
         if ( null != ancestors ) {
            for ( int i = 0; i < ancestors.size(); i++ ) {
               DataObject p = (DataObject) ancestors.elementAt( i );
               if ( null != p ) {
                  Vector members = p.getAttributes();
                  for ( int j = 0; j < members.size(); j++ ) {
                     Attribute attr = (Attribute) members.elementAt( j );
		     memberPrep( attr );
		     sqlMarks(   attr );
		     // former BDO stuff
	             //writeMemberStuff(   attr );
                  }
               }
            }
         }
    }

    public void writeMemberStuff( Attribute  a ) throws Exception {
/* System.err.println("--- writeMemberStuff: a="+a.getName()); */
	/* For an array Attribute, we use a separate template. */
	if ( a.isArray() ) {
	    filterHandleArray.reset();
	    filterHandleArray.process( tagSet );
	    /* Arrays are stored in separate tables,
	     * so the DO does not process them
	     * the way it does other Attributes.
	     */
	    return;
	}

	if ( a.isForeignKey() )
	    memberRemarks += "(FK)";
	if ( a.isPrimaryKey() )
	    memberRemarks += "(PK)";
	tagSet.setTagValue( MEMBER_REMARKS, memberRemarks );

	defaultWriteMemberStuff( a );
	String dbtype = a.getDBType();
//System.err.println("dbtype ="+dbtype );
	if ( columnIsText( dbtype ) ) {
	    filterResultSetExtractionForLONG.reset();
	    filterResultSetExtractionForLONG.process( tagSet );
	} else {
	    filterResultSetExtractions.reset();
	    filterResultSetExtractions.process( tagSet );
	}
	filterMemberDump.reset();
	filterMemberDump.process( tagSet );
	sqlMarks( a );
    }

    /* bits and pieces used by sqlMarks */
    String updateWhereClause = "";
    String commaPK = "";
    String comma = "";

    private void sqlMarks( Attribute  a ) throws Exception {
	if ( a.isConstant() )
	    return;
	filterJDBCsetCalls.reset();
	filterJDBCsetCalls.process( tagSet );
	if ( a.isPrimaryKey() ) {
	    // build up the SQL WHERE clause, used elsewhere.
	    updateWhereClause += commaPK + " " + a.getName() + " = ?";
	    commaPK = ", ";
	    filterJDBCsetCallForNonOidPK.reset();
	    filterJDBCsetCallForNonOidPK.process( tagSet );

	}
/* System.err.println("JDBCsetCalls.toString()="+JDBCsetCalls.toString()); */

	// We could be using 2 more templates to generate the lists of qmarks.
	// But those templates would contain no tags, so it seems best to
	// build the lists of qmarks like this.
	sql_update_question_marks += comma + a.getName() + " = ?";
	sql_insert_column_names   += comma + a.getName();
	sql_insert_question_marks += comma + "?";
	comma = ", ";
    }

    public void writeFileFooter(  DataObject o ) throws Exception {
/* System.err.println("--- writeFileFooter"); */

	tagSet.setTagValue( UPDATE_WHERE_VALUES, JDBCsetCallForNonOidPK.toString() );
	tagSet.setTagValue( UPDATE_WHERE_CLAUSE,
		"\" + getOIdColumnName() + \" = ? and \" + getVersionColumnName() + \" = ?" );
	tagSet.setTagValue( INSERT_COLUMN_NAMES,
		sql_insert_column_names + ", \" + getOIdColumnName() + \", \" + getVersionColumnName() + \"" );

	if ( 0 != updateWhereClause.length() ) {
	    tagSet.setTagValue( UPDATE_WHERE_CLAUSE, updateWhereClause );
//System.err.println("updateWhereClause ="+updateWhereClause );
	    tagSet.setTagValue( INSERT_COLUMN_NAMES, sql_insert_column_names );
	}

	tagSet.setTagValue( INSERT_QUESTION_MARKS,
		sql_insert_question_marks );
	tagSet.setTagValue( UPDATE_QUAL_QUESTION_MARKS,
		sql_update_question_marks );
	if ( null != JDBCsetCalls )
	    tagSet.setTagValue( PREP_STMT_PARAM_CALLS,
		JDBCsetCalls.toString() );
	if ( null != ResultSetExtractionForLONG )
	    tagSet.setTagValue( RESULT_SET_EXTRACTION_FOR_LONG_CALLS,
		ResultSetExtractionForLONG.toString() );
	if ( null != ResultSetExtractions )
	    tagSet.setTagValue( RESULT_SET_EXTRACTION_CALLS,
		ResultSetExtractions.toString() );
	if ( null != memberDump )
	    tagSet.setTagValue( TO_STRING, memberDump.toString() );
	if ( null != handleArray )
	    tagSet.setTagValue( ARRAY_GET_METHODS, handleArray.toString() );
// GET_REFERRERS scrapped in favor of N21_REFERRERS
/* 	if ( null != getReferrers ) */
/* 	    tagSet.setTagValue( GET_REFERRERS, getReferrers.toString() ); */

	// former BDO stuff
	tagSet.setTagValue( STUBS_FOR_COMMIT_ASSERTIONS,
		StubForCommitAssertions.toString() );
	tagSet.setTagValue( COMMIT_REFERENCED_DOS,
		CommitDeleteOtherDOs.toString() );
        if ( null != n21Referrers )
            tagSet.setTagValue( N21_REFERRERS, n21Referrers.toString() );
        if ( null != n2nReferrers )
            tagSet.setTagValue( N2N_REFERRERS, n2nReferrers.toString() );
        if ( null != cascadingDeletes )
            tagSet.setTagValue( CASCADING_DELETES, cascadingDeletes.toString());

	defaultWriteFileFooter( o );

/* 	filterGetReferrers.close(); */
	filterHandleArray.close();
	filterResultSetExtractionForLONG.close();
	filterResultSetExtractions.close();
	filterMemberDump.close();
	filterJDBCsetCalls.close();

	// former BDO stuff
        filterN21Referrers.close();
        filterN2NReferrers.close();
	filterCascadingDeletes.close();
	filterStubForCommitAssertions.close();
	filterCommitDeleteOtherDOs.close();
    }

    private void generateFKstuff( DataObject o ) throws Exception {
	tagSet.setTagValue( FK_GET_SET_METHODS, "" );

	// template reader & filter for FK_get_set_methods.template file.
	// The FK_GET_SET_METHODS tag contains a get and set method
	// for each table (DO) that is referenced by one or more foreign keys.
	// "Foreign keys" are references to user-defined primary keys
	// in another table.
	// In DODS, references to a table using 'oid' as the primary key
	// are just "references", not "foreign keys".
	TemplateReader reader = new TemplateReader(
	    info.templateDir + File.separator + "FK_get_set_methods.template");
	StringWriter FKgetSetMethods = new StringWriter();
	TemplateFilter filterFKgetSetMethods = new TemplateFilter(
						reader, FKgetSetMethods);

	// template reader & filter for FK_setQuery_calls.template file.
	reader = new TemplateReader(
	    info.templateDir + File.separator + "FK_setQuery_calls.template" );
	StringWriter FKsetQueryCalls = new StringWriter();
	TemplateFilter filterFKsetQueryCalls = new TemplateFilter(
						reader, FKsetQueryCalls );

	// template reader & filter for FK_set_calls.template file.
	// This builds up the FK_SET_CALLS tag that is used in 
	// the FK_get_set_methods.template.
	reader = new TemplateReader(
	    info.templateDir + File.separator + "FK_set_calls.template" );
	StringWriter FKsetCalls = new StringWriter();
	TemplateFilter filterFKsetCalls = new TemplateFilter(
						reader, FKsetCalls );
	
	numColumnsInFK = new Hashtable();
	fkNameByFkRef = new Hashtable();

	Hashtable fkByDO = o.getForeignKeysGroupedByReferencedDO();
	for ( Enumeration e = fkByDO.keys(); e.hasMoreElements(); ) {
	    DataObject referencedDO = (DataObject) e.nextElement();
	    // o has FK(s) that reference user-defined PK(s) in referencedDO.
	    // Generate calls to setQuery<FK> methods which will
	    // comprise the body of the get() method.
	    // Generate calls to set<FK> methods which will
	    // comprise the body of the set() method.
	    String fkRef = referencedDO.getName();

	    Hashtable fkGroups = (Hashtable) fkByDO.get( referencedDO );
	    int numGroups = fkGroups.size();
//System.err.println("fkGroups.size()="+fkGroups.size());
	    for ( Enumeration e2 = fkGroups.keys(); e2.hasMoreElements(); ) {
		String fkGroup = (String) e2.nextElement();
//System.err.println("fkGroup ="+fkGroup );

		String getMethodName = "_" + fkGroup;
		String setMethodName = "_" + fkGroup;

		Vector v = (Vector) fkGroups.get( fkGroup );
		for ( int i = 0; i < v.size(); i++ ) {
		    String[] pk_fk_pair = (String[]) v.elementAt(i);
		    String pkName = pk_fk_pair[0];
//System.err.println("pkName ="+pkName );
		    String fkName = pk_fk_pair[1];
//System.err.println("fkName ="+fkName );

		    /*
		    if ( numGroups > 1 ) {
			getMethodName += "_" + fkName;
			setMethodName =  "_" + fkName + setMethodName;
		    }
		    */
//System.err.println("getMethodName ="+getMethodName );
//System.err.println("setMethodName ="+setMethodName );

		    // prepare data for setting START_MEMBER_NOT_IN_COMBO_FK tag
//System.err.println("fkName="+fkName);
//System.err.println("v.size()="+v.size());
		    numColumnsInFK.put( fkName, new Integer( v.size() ) );
		    fkNameByFkRef.put( fkName, fkRef );

		    // set tags for generating method contents
		    setTagUpperMemberName( UPPER_PK_MEM_NAME, pkName );
		    setTagUpperMemberName( UPPER_FK_MEM_NAME, fkName );
		    filterFKsetQueryCalls.reset();
		    filterFKsetQueryCalls.process( tagSet );
		    filterFKsetCalls.reset();
		    filterFKsetCalls.process( tagSet );
		}

		// Generate the get & set methods for the DOs referenced by FKs.
		setTagUpperMemberName( FK_REF, fkRef );
		setTagUpperMemberName( FK_REF_GET_METHOD, getMethodName );
		setTagUpperMemberName( FK_REF_SET_METHOD, setMethodName );
		tagSet.setTagValue( FK_SETQUERY_CALLS,
						FKsetQueryCalls.toString() );
		tagSet.setTagValue( FK_SET_CALLS,      FKsetCalls.toString() );
		filterFKgetSetMethods.reset();
		filterFKgetSetMethods.process( tagSet );
	    }
	}
	filterFKsetQueryCalls.close();
	filterFKsetCalls.close();
	filterFKgetSetMethods.close();
	tagSet.setTagValue( FK_GET_SET_METHODS, FKgetSetMethods.toString() );
    }

}
