/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: FileUtil.java,v 1.1 2001/09/28 16:01:06 cryd0221 Exp $
 */

package org.enhydra.dods.common;

import java.io.*;
import java.util.Random;

public class FileUtil {

  public static void copyFile(File source, File dest)
      throws java.io.FileNotFoundException,
             java.io.IOException {

     File parentFile = new File(dest.getParent());
     parentFile.mkdirs();

     BufferedInputStream  in  = new BufferedInputStream(new FileInputStream(source));
     BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(dest));

     int cursor = in.read();
     while (cursor != -1) {
        out.write(cursor);
        cursor = in.read();
     }
     in.close();
     out.flush();
     out.close();
  }

}
