/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.dods.common;

//
public class Main {

    //
    private final String PARAM_REGEN = "regen";    // nores

    public Main() {}

    public static void main(String[] args) {
        Main main = new Main();

        try {
            main.init(args);
        } catch (Exception e) {
            e.printStackTrace(System.err);
        }
    }

    private void init(String[] args) throws Exception {
        boolean generator = false;

        if (isGenerator(args) || isHelp(args)) {
            org.enhydra.dods.builder.engine.Builder.main(args);
        } else {
            org.enhydra.dods.merlot.DOMLEditor.main(args);
        }
    }

    private boolean isGenerator(String[] args) {
        boolean generator = false;

        if (args.length > 2) {
            generator = args[2].equalsIgnoreCase(PARAM_REGEN);
        }
        return generator;
    }

    private boolean isHelp(String[] args) {
        boolean help = false;

        for (int i = 0; i < args.length; i++) {
            if (args[i].equalsIgnoreCase("help")
                    || args[i].equalsIgnoreCase("-help")
                    || args[i].equalsIgnoreCase("-h")) {
                help = true;
            }
            break;
        }
        return help;
    }

}
