/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: PackageTreeModel.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */
package org.enhydra.dods.gui.tree;

import javax.swing.tree.DefaultTreeModel;

/**
 * Tree for navigating packages. This class replaces DOEditorTreeModel.
 * 
 * @author  Paul Mahar
 * @version 
 */
public class PackageTreeModel extends DefaultTreeModel {

    /**
     * This constructor creates the model.
     */
    public PackageTreeModel(PackageTreeNode root) {
	super(root);
    }

    /**
     * Find a node containing a given user object. The found node may be the root
     * node or any descendents.
     *
     * @param userObject
     * The object to look for.
     *
     * @return
     * A node containing the userObject or null if the userObject is not found.
     *
     */
    public PackageTreeNode getNodeContaining(Object userObject) {
	PackageTreeNode node = null;

	node = (PackageTreeNode) this.getRoot();
	node = node.getNodeContaining(userObject);

	return node;
    } 

}


