/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: PackageTreeSelectionListener.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */



package org.enhydra.dods.gui.tree;

import org.enhydra.dods.store.doa.DOPackage;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.JTree;
import javax.swing.JTextField;
/**
 * This class updates the PackageName textfield when a new package is selected
 * in the DataObjectEditor.
 */
public class PackageTreeSelectionListener implements TreeSelectionListener {
    private JTree tree;
    private JTextField packageName;
    /**
     * This initializes the appropriate variables.
     */
    public PackageTreeSelectionListener(JTree tre, JTextField packageNam) {
        tree = tre;
        packageName = packageNam;
    }
    /**
     * When the new node is selected its name is put in the appropriate TextField.
     */
    public void valueChanged(TreeSelectionEvent e) {
      PackageTreeNode node = null;
      DOPackage pack;
      if (tree.getLastSelectedPathComponent() instanceof PackageTreeNode) {
        node = (PackageTreeNode) tree.getLastSelectedPathComponent();
        pack = (DOPackage) node.getUserObject();
        if (tree.getLastSelectedPathComponent() !=null ) {
            if(! node.isLeaf()) {
              packageName.setText(pack.getPackageName()+"."+pack.getName());
              if(pack.getPackageName().equals("")){
                 packageName.setText(pack.getName());
              }
            }
          }
        }
    }
}
