/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: AbstractAttributeCombo.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot;

// Merlot imports
import org.merlotxml.merlot.*;
import org.merlotxml.util.xml.*;
import org.w3c.dom.*;

// Standard imports
import javax.swing.*;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author Paul Mahar
 * @version $Revision: 1.1 $
 */
abstract public class AbstractAttributeCombo extends JComboBox
     implements Saver {

    private MerlotDOMNode node = null;

    abstract public void init();
    abstract public String getAttributeName();

    public MerlotDOMNode getNode() {
      return node;
    }

    public void setNode(MerlotDOMNode n) {
      node = n;
    }

    public String getNodeValue(String atName) {
        NodeUtil util = null;
        String value = null;
        util = new NodeUtil();
        value = util.lookupAttributeValue(node, atName);
        return value;
    }

    public String getNodeValue() {
        String value = null;
        value = getNodeValue(getAttributeName());
        return value;
    }

    public void saveValue(AbstractValidationPanel owner) throws PropertyVetoException {
        String  newValue = getSelectedItem().toString();
        String atName = getAttributeName();
        HashMap map = new HashMap();
        map.put(atName, newValue);
        owner.saveValue(map);
    }
}
