/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: AbstractJavaIdentField.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot;

// Merlot imports
import org.merlotxml.merlot.*;
import org.merlotxml.util.xml.*;

// Standard imports
import javax.swing.*;
import javax.swing.text.AttributeSet;
import javax.swing.text.Document;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;
import java.awt.event.*;
import java.util.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author Paul Mahar
 * @version $Revision: 1.1 $
 */
abstract public class AbstractJavaIdentField extends AbstractAttributeTextField
   implements Validator {

  protected Document createDefaultModel() {
     return new LocalDocument();
   }

  class LocalDocument extends PlainDocument {

        public void insertString(int offs, String str, AttributeSet a)
          throws BadLocationException {

           if (str == null) {
              return;
           }
           StringBuffer buf = new StringBuffer();
           char[] chars = str.toCharArray();
           for (int i = 0; i < chars.length; i++) {
             if (offs == 0 && i == 0) {
               if (Character.isJavaIdentifierStart(chars[0])) {
                 buf.append(chars[0]);
               }
             } else if (Character.isJavaIdentifierPart(chars[i])) {
               buf.append(chars[i]);
             }
           }
           super.insertString(offs, buf.toString(), a);
        }
  }

}
