/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: BuilderMessageFrame.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */
package org.enhydra.dods.merlot;

// Swing imports
import javax.swing.*;

// AWT imports
import java.awt.*;
import java.awt.event.*;

import org.enhydra.dods.builder.engine.MessageListener;

public class BuilderMessageFrame extends JFrame implements MessageListener, ActionListener {

	private final static String TITLE = "DODS Generator Messages";
	private final static String OK_BUTTON_TEXT = "Ok";
	private JTextArea display;
	private JPanel buttonPanel;
	private JButton okButton;

	public BuilderMessageFrame() {
		super(TITLE);

		Container c = getContentPane();
		c.setLayout(new BoxLayout(c, BoxLayout.Y_AXIS));

		display = new JTextArea();
		c.add(new JScrollPane(display));

		c.add(Box.createVerticalStrut(10));

		okButton = new JButton(OK_BUTTON_TEXT);
		okButton.addActionListener(this);
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.add(okButton);
		c.add(buttonPanel);

		c.add(Box.createVerticalStrut(10));

		setSize(800, 400);
		show();
	}

	public void messageSent(String message) {
		if (message != null) {
			display.append("\n" + message);
			display.setCaretPosition(message.length());
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == okButton) {
			dispose();
		}
	}
}
