/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: DOMLEditor.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot;

import org.enhydra.dods.store.doml.DOMLConstants;

import org.merlotxml.merlot.XMLEditor;
import org.merlotxml.merlot.MerlotException;
import org.merlotxml.merlot.MerlotDebug;

import java.awt.Container;
import java.awt.Component;

public class DOMLEditor extends XMLEditor implements DOMLConstants {

    public DOMLEditor(String[] args) throws MerlotException {
        super(args);
    }

    public static void main (String[] args) {
        try {
            DOMLEditor editor = new DOMLEditor(args);
            editor.run();
        }
        catch (MerlotException e) {
            e.printStackTrace();
            MerlotDebug.exception(e);
        }

    }

    public static boolean isLink(String type) {
      boolean link = false;
      if ((type != null) && (type.trim().length() > 0)) {
        link = true;
        for (int i = 0; i < JAVA_TYPE_LIST.length; i++) {
          if (type.equalsIgnoreCase(JAVA_TYPE_LIST[i])) {
            link = false;
            break;
          }
        }
      }
      return link;

    }

    public static Component findComponentByClass(Container container,
              Class lookupClass) {
      Component found = null;
      Component[] children = new Component[0];
      if (container != null) {
        children = container.getComponents();
      }
      for (int i = 0 ; i < children.length ; i++ ) {
        if (children[i] == null) {
           // skip
        } else if (children[i].getClass().equals(lookupClass)) {
          found = children[i];
        } else if (children[i] instanceof Container) {
          found = DOMLEditor.findComponentByClass(
              (Container)children[i], lookupClass);
        }
        if (found != null) {
          break;
        }
      }
      return found;
   }

}


