/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: ClassEditPanel.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot.cls;

// DOML plug-in imports
import org.enhydra.dods.merlot.AbstractAttributeCombo;
import org.enhydra.dods.merlot.AbstractValidationPanel;
import org.enhydra.dods.merlot.ValidationException;

// Merlot imports
import org.merlotxml.merlot.*;
import org.merlotxml.util.xml.*;
import org.w3c.dom.*;

// Standard imports
import javax.swing.*;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author Paul Mahar
 * @version $Revision: 1.1 $
 */
public class ClassEditPanel extends AbstractValidationPanel {
    private String atName = null;


    /**
     * Constructor declaration
     *
     *
     * @param node
     *
     * @see
     */
    public ClassEditPanel(MerlotDOMNode node) {
        super(node);
    }


    /**
     * Overloads the generic call to get a color chooser button if the attr name is "color"
     */
    protected JComponent getEditComponent(DTDAttribute attr) {
    	JComponent comp = null;
    	atName = attr.getName().trim();
        if (atName.equalsIgnoreCase(NameTextField.ATTRIBUTE_NAME)) {
          NameTextField nameText = new NameTextField();
          nameText.setNode(this._node);
          nameText.init();
          comp = nameText;
        } else if (atName.equalsIgnoreCase(TableTextField.ATTRIBUTE_NAME)){
          TableTextField tableText = new TableTextField();
          tableText.setNode(this._node);
          tableText.init();
          comp = tableText;
        } else if (atName.equalsIgnoreCase(ExtendsCombo.ATTRIBUTE_NAME)){
          ExtendsCombo exCombo = new ExtendsCombo();
          exCombo.setNode(this._node);
          exCombo.init();
          comp = exCombo;
	  } else if (atName.equalsIgnoreCase(VendorCombo.ATTRIBUTE_NAME)){
	    	VendorCombo vendorCombo = new VendorCombo();
		vendorCombo.setNode(this._node);
		vendorCombo.init();	
		comp = vendorCombo;
        } else {
          comp = super.getEditComponent(attr);
        }
        return comp;
    }



}
