/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: VendorCombo.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot.cls;

// DODS imports
import org.enhydra.dods.store.doml.DOMLConstants;

// DOML plug-in imports
import org.enhydra.dods.merlot.AbstractAttributeCombo;
import org.enhydra.dods.merlot.NodeUtil;

// Merlot imports
import org.merlotxml.merlot.*;
import org.merlotxml.util.xml.*;
import org.w3c.dom.*;

// Standard imports
import javax.swing.*;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.*;
import java.util.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author Omead Jensen
 * @version $Revision: 1.1 $
 */
public class VendorCombo extends AbstractAttributeCombo implements DOMLConstants {

    public static final String ATTRIBUTE_NAME = "vendor";


    /**
     * Constructor declaration
     *
     *
     * @param node
     *
     * @see
     */
    public VendorCombo() {
	super();
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public String getAttributeName() {
	return VendorCombo.ATTRIBUTE_NAME;
    }

    /**
     * Overloads the generic call to get a color chooser button if the attr name is "color"
     */
    public void init() {

	populate();

    }


    /**
     * Method declaration
     *
     *
     * @param value
     *
     * @see
     */
	public void populate() {

		removeAllItems();

		for(int i = 0; i < VENDOR_ATTRIBUTE_LIST.length; i++) {
			addItem(VENDOR_ATTRIBUTE_LIST[i]);
		}

		refresh();
	}


    /**
     * Method declaration
     *
     *
     * @param value
     *
     * @see
     */
	public void refresh() {

		NodeUtil util = new NodeUtil();
		MerlotDOMNode vendorNode = util.findParentVendorNode(getNode());
	
		if (vendorNode != null) {
			String savedValue = util.lookupAttributeValue(getNode(), CLASS_VENDOR_ATTRIBUTE);

			if (savedValue != null) {
				if (savedValue.equals(DEFAULT_CLASS_VENDOR)) {
        				String vendorNameAttribute 
						= util.lookupAttributeValue(vendorNode, VENDOR_NAME_ATTRIBUTE);

					if (vendorNameAttribute != null) {
						setSelectedItem(vendorNameAttribute);	
					} else {
						setSelectedItem(DEFAULT_CLASS_VENDOR);
					}
				} else {
					setSelectedItem(savedValue);
				}
			} else {
				setSelectedItem(DEFAULT_CLASS_VENDOR);
			}
		} else {
			String savedValue = util.lookupAttributeValue(getNode(), CLASS_VENDOR_ATTRIBUTE);
			if (savedValue != null) {
				setSelectedItem(savedValue);
			} else {
				setSelectedItem(DEFAULT_CLASS_VENDOR);
			}
		}	
	}

} // class


