/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: DefaultEditPanel.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot.def;

// DODS imports
import org.enhydra.dods.merlot.AbstractValidationPanel;
import org.enhydra.dods.merlot.ValidationException;

// Merlot imports
import org.merlotxml.merlot.*;
import org.merlotxml.util.xml.*;
import org.w3c.dom.*;

// Standard imports
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.Container;
import java.awt.Component;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author Paul Mahar
 * @version $Revision: 1.1 $
 */
public class DefaultEditPanel extends AbstractValidationPanel {
    private JTextArea           textArea = null;

    /**
     * Constructor declaration
     *
     *
     * @param node
     *
     * @see
     */
    public DefaultEditPanel(MerlotDOMNode node) {
        super(node);
        pmInit();
    }


    /**
     * Method declaration
     *
     *
     * @see
     */
    private void pmInit() {
        initTextArea();
    }


    /**
     * Method declaration
     *
     *
     * @see
     */
    private void initTextArea() {
        int       count = getComponentCount();
        JViewport viewport = null;

        for (int i = 0; i < count; i++) {
            if (getComponent(i) instanceof JScrollPane) {
                JScrollPane scrollPane = null;

                scrollPane = (JScrollPane) getComponent(i);
                viewport = scrollPane.getViewport();
            }
        }
        if (viewport != null) {
            count = viewport.getComponentCount();
            for (int i = 0; i < count; i++) {
                if (viewport.getComponent(i) instanceof JTextArea) {
                    textArea = (JTextArea) viewport.getComponent(i);
                    break;
                }
            }
        }
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void grabFocus() {
        super.grabFocus();
        textArea.grabFocus();
    }

    /**
     * Method declaration
     *
     *
     * @exception ValidationException
     *
     * @see
     */
    public void validateValues() throws ValidationException {
        if (textArea.getText().trim().length() == 0) {
            throw new ValidationException("text cannot be blank");
        }
    }

}

