/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: FieldEditPanel.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot.field;

// DOML plug-in imports
import org.enhydra.dods.merlot.AbstractAttributeCombo;
import org.enhydra.dods.merlot.AbstractValidationPanel;

// Merlot imports
import org.merlotxml.merlot.*;
import org.merlotxml.util.xml.*;
import org.w3c.dom.*;

// Standard imports
import javax.swing.*;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author Paul Mahar
 * @version $Revision: 1.1 $
 */
public class FieldEditPanel extends AbstractValidationPanel {
    private String atName = null;

    /**
     * Constructor declaration
     *
     *
     * @param node
     *
     * @see
     */
    public FieldEditPanel(MerlotDOMNode node) {
        super(node);
    }

    /**
     * Overloads the generic call to get a color chooser button if the attr name is "color"
     */
    protected JComponent getEditComponent(DTDAttribute attr) {
    	JComponent editComp = null;

    	atName = attr.getName().trim();
        if (atName.equalsIgnoreCase(DatabaseTypeCombo.ATTRIBUTE_NAME)) {
          AbstractAttributeCombo combo = null;
          combo = new DatabaseTypeCombo();
          combo.setNode(this._node);
          combo.init();
          editComp = combo;
        } else if (atName.equalsIgnoreCase(ConstraintCombo.ATTRIBUTE_NAME)) {
          AbstractAttributeCombo combo = null;
          combo = new ConstraintCombo();
          combo.setNode(this._node);
          combo.init();
          editComp = combo;
        } else if (atName.equalsIgnoreCase(JavaTypeCombo.ATTRIBUTE_NAME)) {
          AbstractAttributeCombo combo = null;
          combo = new JavaTypeCombo();
          combo.setNode(this._node);
          combo.init();
          editComp = combo;
        } else if (atName.equalsIgnoreCase(NameTextField.ATTRIBUTE_NAME)) {
          NameTextField text = null;
          text = new NameTextField();
          text.setNode(this._node);
          text.init();
          editComp = text;
       } else if (atName.equalsIgnoreCase(SizeTextField.ATTRIBUTE_NAME)) {
          SizeTextField text = null;
          text = new SizeTextField();
          text.setNode(this._node);
          text.init();
          editComp = text;
        } else {
          editComp = super.getEditComponent(attr);
        }
        return editComp;
    }


}
