/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: FieldEditor.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */

package org.enhydra.dods.merlot.field;

import javax.swing.*;
import java.util.*;
import java.beans.PropertyVetoException;
import org.merlotxml.merlot.*;
import org.merlotxml.util.xml.*;


public class FieldEditor implements MerlotDOMEditor
{
    /**
     * Returns a set of menu items for any special actions for
     * this particular editor
     * that it wants in the popup menu. Standard stuff like cut, copy, paste
     * is taken care of by other objects. If nothing needs added,
     * can return null.
     *
     * @param node the node for which to get the menu items
     */
    public  JMenuItem[] getMenuItems(MerlotDOMNode node)
    {
        return null;
    }



    /**
     * returns a panel for editing this type of component.
     */
    public JPanel getEditPanel(MerlotDOMNode node)
    {
        return new FieldEditPanel(node);

    }


    /**
     * called by the editor when the user has chosen to save their
     * changes in a panel.
     * @param p the panel that was retreived with getEditPanel(node);
     *
     */
    public void savePanel(JPanel p)
        throws PropertyVetoException
    {
        if (p instanceof FieldEditPanel) {
            ((FieldEditPanel)p).save();
        }
    }


    /**
     * Tells the edit panel it's gaining focus, so it can put the cursor in the first
     * field. XXX this should probably be handled by event listening instead
     */
    public void grabFocus(JPanel p)
    {
    }



    /**
     * Returns true if the component editor wants a particular node hidden
     * from the user. If the editor wants to filter
     * what the user sees in their display, it should look at the
     * given node, otherwise it should return false. This is usefull
     * particularly if the editor handles its children. It can hide
     * the children nodes from the user's view.
     */
    public boolean suppressNode(MerlotDOMNode node)
    {
        return false;
    }



    /**
     * allows the plugin to hide certain items on the add-> menu. For
     * example, the plugin for the accessibility permissions might not
     * want the user to be able to directly add an "access" element, so
     * it can request that that be suppressed.
     */
    public boolean suppressAddType(DTDElement el)
    {
        return false;

    }




}
