/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: DODSProject.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */
package org.enhydra.dods.store.doa;

import java.io.File;
/**
 * A DODSProject is a DOPackage which is the root of a project.  It contains
 * the information about what file it is stored in and what kind of database
 * these DataObjects will be contained in. (ie. Oracle, Informix, etc.)
 *
 * @author  Philip Martin
 * @version $Revision: 1.1 $
 */
public class DODSProject extends DOPackage {
    /**
     * This is the file that the DODSProject is being stored in.  It is null
     * if the project hasn't been saved yet.
     */
    protected File file;
    /**
     * This constructor sets up the name of the Root Package.
     */
    public DODSProject(String name) {
        super(name);
    }
    /**
     * This constructor uses "ProjectRoot" as the Root package name.
     */
    public DODSProject() {
        super("ProjectRoot");
    }
    /**
     * Sets the file that this project is stored in.
     */
    public void setFile(File f) {
        file = f;
    }
    /**
     * @return The file to store this project in.
     */
    public File getFile() {
        return file;
    }
}
