/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: DOMLWarning.java,v 1.1 2001/09/28 16:01:07 cryd0221 Exp $
 */


package org.enhydra.dods.store.doml;

/**
 * Warning class for all non-fatal parsing errors that occur while using the
 * DODML tools.
 */
public class DOMLWarning extends com.lutris.util.ChainedException
{
    /**
     * Constructor.
     */
    public DOMLWarning(String message)
    {
	super(message);
    }

    /**
     * Constructor. The given exception will be chained with the warning and
     * can be retrieved later with the <b>getCause</b> call.
     */
    public DOMLWarning(Exception e,
			String    message)
    {
	super(message, e);
    }
}
